unit FreeOTFEfrmMain;
// Description:
// By Sarah Dean
// Email: sdean12@sdean12.org
// WWW:   http://www.FreeOTFE.org/
//
// -----------------------------------------------------------------------------
//


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Spin, StdCtrls, ComCtrls, ImgList, ExtCtrls, Grids, Menus, OTFE_U,
  OTFEFreeOTFE_U, Shredder, MouseRNGDialog_U, ActnList,
  FreeOTFESettings, SDUSystemTrayIcon, ToolWin, Buttons, XPMan;


type
  TPortableModeAction = (pmaStart, pmaStop, pmaToggle);

  TfrmFreeOTFEMain = class(TForm)
    ilDriveIcons: TImageList;
    lvDrives: TListView;
    pmDrives: TPopupMenu;
    miPopupDismount: TMenuItem;
    mmMain: TMainMenu;
    File1: TMenuItem;
    miFreeOTFEMountFile: TMenuItem;
    miDismountMain: TMenuItem;
    miExit: TMenuItem;
    N2: TMenuItem;
    miPopupProperties: TMenuItem;
    N3: TMenuItem;
    miFreeOTFENew: TMenuItem;
    View1: TMenuItem;
    miProperties: TMenuItem;
    N1: TMenuItem;
    miRefresh: TMenuItem;
    OpenDialog: TOpenDialog;
    Help1: TMenuItem;
    About1: TMenuItem;
    miDismountAllMain: TMenuItem;
    miPopupDismountAll: TMenuItem;
    N4: TMenuItem;
    miLinuxVolume: TMenuItem;
    miLinuxNew: TMenuItem;
    miLinuxMountFile: TMenuItem;
    OTFEFreeOTFE: TOTFEFreeOTFE;
    N5: TMenuItem;
    miFreeOTFEDrivers: TMenuItem;
    miLinuxDismount: TMenuItem;
    miTools: TMenuItem;
    miOverwriteFreeSpace: TMenuItem;
    miFormat: TMenuItem;
    N6: TMenuItem;
    miPopupFormat: TMenuItem;
    miPopupOverwriteFreeSpace: TMenuItem;
    MouseRNGDialog1: TMouseRNGDialog;
    N7: TMenuItem;
    miPortableModeDrivers: TMenuItem;
    N8: TMenuItem;
    miCDBBackup: TMenuItem;
    miCDBRestore: TMenuItem;
    miCreateKeyfile: TMenuItem;
    miChangePassword: TMenuItem;
    miCDBPlaintextDump: TMenuItem;
    miCDB: TMenuItem;
    miFreeOTFEMountPartition: TMenuItem;
    miLinuxMountPartition: TMenuItem;
    N9: TMenuItem;
    miLUKSDump: TMenuItem;
    ActionList1: TActionList;
    actFreeOTFENew: TAction;
    actFreeOTFEMountFile: TAction;
    actFreeOTFEMountPartition: TAction;
    actDismount: TAction;
    actDismountAll: TAction;
    actLinuxNew: TAction;
    actLinuxMountFile: TAction;
    actLinuxMountPartition: TAction;
    actProperties: TAction;
    pmSystemTray: TPopupMenu;
    actExit: TAction;
    open1: TMenuItem;
    open2: TMenuItem;
    mountfile1: TMenuItem;
    mountpartition1: TMenuItem;
    dismountall1: TMenuItem;
    N10: TMenuItem;
    miOptions: TMenuItem;
    actDisplayConsole: TAction;
    N11: TMenuItem;
    N12: TMenuItem;
    SDUSystemTrayIcon1: TSDUSystemTrayIcon;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ilToolbarIcons: TImageList;
    actTogglePortableMode: TAction;
    StatusBar1: TStatusBar;
    actFormat: TAction;
    actOverwriteFreeSpace: TAction;
    pbtbTogglePortableMode: TToolButton;
    XPManifest1: TXPManifest;
    actDrivers: TAction;
    actRefresh: TAction;
    procedure actDriversExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure actRefreshExecute(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure lvDrivesResize(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure lvDrivesClick(Sender: TObject);
    procedure lvDrivesDblClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure miCDBBackupClick(Sender: TObject);
    procedure miCDBRestoreClick(Sender: TObject);
    procedure miCreateKeyfileClick(Sender: TObject);
    procedure miChangePasswordClick(Sender: TObject);
    procedure miCDBPlaintextDumpClick(Sender: TObject);
    procedure miLUKSDumpClick(Sender: TObject);
    procedure actFreeOTFENewExecute(Sender: TObject);
    procedure actFreeOTFEMountFileExecute(Sender: TObject);
    procedure actFreeOTFEMountPartitionExecute(Sender: TObject);
    procedure actDismountExecute(Sender: TObject);
    procedure actDismountAllExecute(Sender: TObject);
    procedure actLinuxNewExecute(Sender: TObject);
    procedure actLinuxMountFileExecute(Sender: TObject);
    procedure actLinuxMountPartitionExecute(Sender: TObject);
    procedure actPropertiesExecute(Sender: TObject);
    procedure actExitExecute(Sender: TObject);
    procedure miOptionsClick(Sender: TObject);
    procedure actDisplayConsoleExecute(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure actTogglePortableModeExecute(Sender: TObject);
    procedure lvDrivesSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure actFormatExecute(Sender: TObject);
    procedure actOverwriteFreeSpaceExecute(Sender: TObject);
    procedure pbtbTogglePortableModeMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);

  private
    // Flag to indicate that the login session is about to end
    EndSessionFlag: boolean;
    // Flag to indicate that the executable is about to exit
    ShuttingDownFlag: boolean;

    TempCypherDriver: string;
    TempCypherGUID: TGUID;
    TempCypherDetails: TFreeOTFECypher;
    TempCypherKey: string;
    TempCypherIV: int64;

    IconMounted: TIcon;
    IconUnmounted: TIcon;

    // We cache this information as it take a *relativly* long time to get it
    // from the OTFE component.
    CountPortableDrivers: integer;

  protected
    AllowUACEsclation: boolean;

    function  ActivateFreeOTFEComponent(suppressMsgs: boolean): boolean;
    procedure DeactivateFreeOTFEComponent();

    procedure InitializeDrivesDisplay();
    procedure RefreshDrives();
    function  AddIconForDrive(driveLetter: char): integer;

    procedure EnableDisableControls();
    function  GetDriveLetterFromLVItem(listItem: TListItem): char;

    procedure DumpDetailsToFile(LUKSDump: boolean);

    procedure ResizeWindow();

    // Set "mountAsSystem" to either:
    //   FREEOTFE
    //   LINUX
    //   PROMPT
    procedure MountFiles(mountAsSystem: TDragDropFileType; filenames: TStringList; readOnly: boolean);

    procedure DriveProperties();

    function  DismountSelected(): boolean;
    function  DismountAll(isEmergency: boolean = FALSE): boolean;
    function  DismountDrives(dismountDrives: string; isEmergency: boolean): boolean;
    procedure ReportDrivesNotDismounted(drivesRemaining: string; isEmergency: boolean);

    function  PortableModeSet(setTo: TPortableModeAction; suppressMsgs: boolean): boolean;
    function  _PortableModeStart(suppressMsgs: boolean): boolean;
    function  _PortableModeStop(suppressMsgs: boolean): boolean;
    function  _PortableModeToggle(suppressMsgs: boolean): boolean;

    // System tray icon related...
    procedure SystemTrayIconDismount(Sender: TObject);
    procedure DestroySysTrayIconMenuitems();

    // Hotkey related...
    procedure SetupHotKeys();
    procedure EnableHotkey(hotKey: TShortCut; hotKeyIdent: integer);
    procedure DisableHotkey(hotKeyIdent: integer);

    // Vista fix
    procedure WMSyscommand(var Message: TWmSysCommand); message WM_SYSCOMMAND;
    procedure AddUACShieldIcons();

    procedure UACEscalateForDriverInstallation();
    procedure UACEscalateForPortableMode(portableAction: TPortableModeAction; suppressMsgs: boolean);
    procedure UACEscalate(cmdLineParams: string; suppressMsgs: boolean);

  public
    procedure WMDropFiles(var Msg: TWMDropFiles); message WM_DROPFILES;
    procedure WMDeviceChange(var Msg : TMessage); message WM_DEVICECHANGE;
    procedure WMQueryEndSession(var msg: TWMQueryEndSession); message WM_QUERYENDSESSION;
    procedure WMEndSession(var msg: TWMEndSession); message WM_ENDSESSION;

    procedure GenerateOverwriteData(Sender: TObject; passNumber: integer; bytesRequired: cardinal; var outputBlock: TShredBlock);

    procedure InitApp();

    function MessageHook(var msg: TMessage): boolean;

    // Handle any command line options; returns TRUE if command line options
    // were passed through
    function HandleCommandLineOpts(var exitCode: integer): boolean;

    // Vista fix
    procedure CreateParams(var Params: TCreateParams); override;

  end;

var
  frmFreeOTFEMain: TfrmFreeOTFEMain;
  GLOBAL_VAR_WM_FREEOTFE_RESTORE: cardinal;
  GLOBAL_VAR_WM_FREEOTFE_REFRESH: cardinal;

implementation

{$R *.DFM}
{$R FreeOTFESystemTrayIcons.dcr}

uses
  ShellApi,  // Required for SHGetFileInfo
  Commctrl,  // Required for ImageList_GetIcon
  ComObj,  // Required for StringToGUID
  Math,  // Required for min
  SDUGeneral,
  SDUDialogs,
  About_U,
  FreeOTFEfrmVolProperties,
  FreeOTFEfrmSelectOverwriteMethod,
  FreeOTFEfrmCDBDump,
  FreeOTFEfrmCDBBackupRestore,
  FreeOTFEfrmOptions,
  OTFEConsts_U,
  SDUFileIterator_U;

const
  TEXT_NEED_ADMIN =
           'You need administrator privileges in order to carry out this operation.';


  // Format disk related functions ripped from the Unofficial Delphi FAQ (UDF)
  SHFMT_ID_DEFAULT        = $FFFF;
  // Formating options
  SHFMT_OPT_QUICKFORMAT   = $0000;
  SHFMT_OPT_FULL          = $0001;
  SHFMT_OPT_SYSONLY       = $0002;
  // Error codes
  SHFMT_ERROR             = $FFFFFFFF;
  SHFMT_CANCEL            = $FFFFFFFE;
  SHFMT_NOFORMAT          = $FFFFFFFD;

  R_ICON_MOUNTED   = 'MOUNTED';
  R_ICON_UNMOUNTED = 'UNMOUNTED';

  POPUP_DISMOUNT_INITIAL_TXT = 'Dismount ';

  TAG_SYSTRAYICON_POPUPMENUITEMS = 5000;

  HOTKEY_TEXT_NONE = '(None)';
  HOTKEY_IDENT_DISMOUNT      = 1;
  HOTKEY_IDENT_DISMOUNTEMERG = 2;

  // Command line switch indicator
  // Note: Only used when creating command lines; parsing them is more flexable
  CMDLINE_SWITCH_IND = '/';

  // Command line parameters...
  CMDLINE_NOUACESCALATE = 'noUACescalate';
  CMDLINE_DRIVERINSTALL = 'driverinstall';
  CMDLINE_PORTABLE      = 'portable';
  CMDLINE_START         = 'start';
  CMDLINE_ON            = 'on';
  CMDLINE_STOP          = 'stop';
  CMDLINE_OFF           = 'off';
  CMDLINE_TOGGLE        = 'toggle';
  CMDLINE_MOUNT         = 'mount';
  CMDLINE_FREEOTFE      = 'freeotfe';
  CMDLINE_LINUX         = 'linux';
  CMDLINE_VOLUME        = 'volume';
  CMDLINE_READONLY      = 'readonly';
  CMDLINE_DISMOUNT      = 'dismount';
  CMDLINE_FORCE         = 'force';
  CMDLINE_ALL           = 'all';
  CMDLINE_SUPPRESS      = 'suppress';

  // Command line return values...
  CMDLINE_SUCCESS                            =   0;
  CMDLINE_EXIT_INVALID_CMDLINE               = 100;
  CMDLINE_EXIT_UNABLE_TO_CONNECT             = 101;
  CMDLINE_EXIT_UNABLE_TO_MOUNT               = 102;
  CMDLINE_EXIT_UNABLE_TO_DISMOUNT            = 103;
  CMDLINE_EXIT_UNABLE_TO_START_PORTABLE_MODE = 104;
  CMDLINE_EXIT_UNABLE_TO_STOP_PORTABLE_MODE  = 105;


// External function in shell32.dll
function SHFormatDrive(Handle: HWND; Drive, ID, Options: Word): LongInt;
            stdcall; external 'shell32.dll' name 'SHFormatDrive'


// This procedure is called after OnCreate, and immediatly before the
// Application.Run() is called
procedure TfrmFreeOTFEMain.InitApp();
var
  goForStartPortable: boolean;
begin
  // Hook Windows messages first; if we're running under Vista and the user UAC
  // escalates to start portable mode (below), we don't want to miss any
  // refresh messages the escalated process may send us!
  Application.HookMainWindow(MessageHook);

  InitializeDrivesDisplay();
  // We call EnableDisableControls(...) at this point, to display the
  // toolbar/statusbar as needed
  EnableDisableControls();

  if not(ActivateFreeOTFEComponent(TRUE)) then
    begin
    goForStartPortable := Settings.OptAutoStartPortable;
    if not(goForStartPortable) then
      begin
      goForStartPortable := (SDUMessageDlg(
               'The main FreeOTFE driver does not appear to be installed/running on this computer'+SDUCRLF+
               SDUCRLF+
               'Would you like to start FreeOTFE in portable mode?',
               mtConfirmation,
               [mbYes, mbNo],
               0
              ) = mrYes);
      end;

    if goForStartPortable then
      begin
      PortableModeSet(pmaStart, FALSE);
      end
    else
      begin
      SDUMessageDlg(
             'Please see the "installation" section of the accompanying documentation'+SDUCRLF+
             'for instructions on how to install the FreeOTFE drivers.',
             mtInformation,
             [mbOK],
             0
            );
      end;

    end;

  RefreshDrives();
  EnableDisableControls();
  SetupHotKeys();

end;

procedure TfrmFreeOTFEMain.RefreshDrives();
var
  ListItem: TListItem;
  driveIconNum: integer;
  i: integer;
  volumeInfo: TOTFEFreeOTFEVolumeInfo;
  mounted: string;
  miTmp: TMenuItem;
  strVolID: string;
begin
  // Flush any caches in case a separate instance of FreeOTFE running from the
  // commandline, with escalated UAC changed the drivers installed/running
  OTFEFreeOTFE.CachesFlush();

  // Cleardown all...

  // ...Main FreeOTFE window list...
  lvDrives.Items.Clear();
  ilDriveIcons.Clear();

  // ...System tray icon drives list...
  DestroySysTrayIconMenuitems();

  // In case the drivers have been stopped/started recently, we bounce the
  // FreeOTFE component up and down (silently!)
  DeactivateFreeOTFEComponent();
  ActivateFreeOTFEComponent(TRUE);

  /// ...and repopulate
  if OTFEFreeOTFE.Active then
    begin
    mounted := OTFEFreeOTFE.DrivesMounted();

    for i:=1 to length(mounted) do
      begin
      // ...Main FreeOTFE window list...
      if OTFEFreeOTFE.GetVolumeInfo(mounted[i], volumeInfo) then
        begin
        ListItem := lvDrives.Items.Add;
        ListItem.Caption := '     '+mounted[i]+':';
        ListItem.SubItems.Add(volumeInfo.Filename);
        driveIconNum := AddIconForDrive(mounted[i]);
        if (driveIconNum>=0) then
          begin
          ListItem.ImageIndex := driveIconNum;
          end;
        end
      else
        begin
        // Strange... The drive probably got dismounted between getting the
        // list of mounted drives, and querying them for more information...
        end;


        // The volume ID/label
        strVolID := SDUVolumeID(mounted[i]);
        if strVolID<>'' then
          begin
          strVolID := '['+strVolID+']';
          end;

        // ...System tray icon popup menu...
        miTmp := TMenuItem.Create(nil);
        miTmp.Tag := TAG_SYSTRAYICON_POPUPMENUITEMS;  // We tag our menuitems
                                                      // in order that we can
                                                      // know which ones to
                                                      // remove later
        miTmp.OnClick := SystemTrayIconDismount;
        miTmp.AutoHotkeys := maManual;  // Otherwise the hotkeys added
                                        // automatically can interfere with
                                        // examing the caption to get the drive
                                        // letter when clicked on
        miTmp.Caption := POPUP_DISMOUNT_INITIAL_TXT+mounted[i]+': '+strVolID;
        pmSystemTray.Items.Insert((i-1), miTmp);
      end;

      // Insert a divider into the system tray icon's popup menu after the
      // drives are listed
      if (length(mounted) > 0) then
        begin
        miTmp := TMenuItem.Create(nil);
        miTmp.Caption := '-';
        pmSystemTray.Items.Insert(length(mounted), miTmp);
        end;

    end;


  CountPortableDrivers := OTFEFreeOTFE.DriversInPortableMode();
  EnableDisableControls();

end;


// Tear down system tray icon popup menu menuitems previously added
procedure TfrmFreeOTFEMain.DestroySysTrayIconMenuitems();
var
  i: integer;
  miTmp: TMenuItem;
begin
  for i:=(pmSystemTray.Items.count-1) downto 0 do
    begin
    if (pmSystemTray.Items[i].Tag = TAG_SYSTRAYICON_POPUPMENUITEMS) then
      begin
      miTmp := pmSystemTray.Items[i];
      pmSystemTray.Items.Delete(i);
      miTmp.Free();
      end;
    end;
end;


procedure TfrmFreeOTFEMain.SystemTrayIconDismount(Sender: TObject);
var
  miDismount: TMenuItem;
  drive: char;
  strMenuCaption: string;
  strInitialCaption: string;
begin
  miDismount := TMenuItem(Sender);

  // We do this as Delphi 5 doesn't appear to honour the miTmp.AutoHotkeys
  // we set earlier?!
  strMenuCaption    := StripHotKey(miDismount.Caption);
  strInitialCaption := StripHotKey(POPUP_DISMOUNT_INITIAL_TXT);

  drive := strMenuCaption[Length(strInitialCaption)+1];

  DismountDrives(drive, FALSE);

  RefreshDrives();
end;


// Add an icon to represent the specified drive
// Returns: The icon's index in ilDriveIcons, or -1 on error
function TfrmFreeOTFEMain.AddIconForDrive(driveLetter: char): integer;
var
  iconIdx: integer;
  anIcon: TIcon;
  shfi: SHFileInfo;
  imgListHandle: THandle;
  iconHandle: HICON;
  tmpDrivePath: string;
begin
  iconIdx := -1;
  
  // Create a suitable icon to represent the drive
  tmpDrivePath := driveLetter+':\';
  imgListHandle := SHGetFileInfo(
                                 PChar(tmpDrivePath),
                                 0,
                                 shfi,
                                 sizeof(shfi),
                                 SHGFI_SYSICONINDEX or SHGFI_LARGEICON);
//                                 SHGFI_DISPLAYNAME

  if imgListHandle<>0 then
    begin
    iconHandle := ImageList_GetIcon(imgListHandle, shfi.iIcon, ILD_NORMAL);
    if (iconHandle<>0) then
      begin
      anIcon:= TIcon.Create();
      try
        anIcon.ReleaseHandle();

        anIcon.handle := iconHandle;

        if (ilDriveIcons.Width<anIcon.Width) then
          begin
          ilDriveIcons.Width := anIcon.Width;
          end;
        if (ilDriveIcons.Height<anIcon.Height) then
          begin
          ilDriveIcons.Height := anIcon.Height;
          end;

        iconIdx := ilDriveIcons.addicon(anIcon);

        anIcon.ReleaseHandle();
        DestroyIcon(iconHandle);
      finally
        anIcon.Free();
      end;

      end;
    end;


  Result := iconIdx;

end;

procedure TfrmFreeOTFEMain.InitializeDrivesDisplay();
var
  tmpColumn: TListColumn;
begin
  // Listview setup...
  lvDrives.SmallImages := ilDriveIcons;
  lvDrives.RowSelect:= TRUE;
  lvDrives.MultiSelect:= TRUE;
  lvDrives.showcolumnheaders := TRUE;
  lvDrives.ReadOnly := TRUE;
  lvDrives.ViewStyle := vsReport;
//    lvDrives.ViewStyle := vsIcon;
//    lvDrives.ViewStyle := vsList;
  lvDrives.IconOptions.Arrangement := iaTop;


  // Listview columns...
  tmpColumn := lvDrives.Columns.Add;
  tmpColumn.Caption := 'Drive';
  tmpColumn.width := 100;

//    tmpColumn.minwidth := lvDrives.width;
  tmpColumn := lvDrives.Columns.Add;
  tmpColumn.Caption := 'Volume';
  tmpColumn.width := lvDrives.clientwidth - lvDrives.columns[0].width - ilDriveIcons.width;


// xxx - shouldn't this work?     NewColumn.autosize := TRUE;
// xxx - shouldn't this work?     NewColumn.minwidth := lvDrives.clientwidth - lvDrives.columns[0].width - ilDriveIcons.width;


// xxx - use destroyimage or whatever it was to cleardown the **imagelist**

end;


// Add an icon to represent the specified drive
// Returns: The icon's index in ilDriveIcons, or -1 on error
procedure TfrmFreeOTFEMain.AddUACShieldIcons();
const
  UAC_IDI_SHIELD = 32518;
var
  iconIdx: integer;
  anIcon: TIcon;
  iconHandle: HICON;
begin
  // Create a suitable icon to represent the drive
  iconHandle := LoadImage(
                          0,
                          PChar(UAC_IDI_SHIELD),
                          IMAGE_ICON,
                          ilToolbarIcons.Width,
                          ilToolbarIcons.Height,
                          (LR_CREATEDIBSECTION or LR_SHARED)
                         );
  if (iconHandle <> 0) then
    begin
    anIcon:= TIcon.Create();
    try
      anIcon.ReleaseHandle();

      anIcon.handle := iconHandle;
      {
      if (ilToolbarIcons.Width < anIcon.Width) then
        begin
        ilToolbarIcons.Width := anIcon.Width;
        end;
      if (ilToolbarIcons.Height < anIcon.Height) then
        begin
        ilToolbarIcons.Height := anIcon.Height;
        end;
       }
      iconIdx := ilToolbarIcons.AddIcon(anIcon);

      anIcon.ReleaseHandle();
      DestroyIcon(iconHandle);
    finally
      anIcon.Free();
    end;

    // Set icons on menuitems
    if (iconIdx >= 0) then
      begin
      miFreeOTFEDrivers.ImageIndex := iconIdx;
      miPortableModeDrivers.ImageIndex := iconIdx;
      actFormat.ImageIndex := iconIdx;
      end;

    end;

end;


procedure TfrmFreeOTFEMain.FormCreate(Sender: TObject);
begin
{$IFDEF FREEOTFE_DEBUG}
  OTFEFreeOTFE.DebugShowMessage := FALSE;  // xxx - disable showmessages(...) of debug if built with debug on
{$ENDIF}

  // Vista fix
  if SDUOSVistaOrLater() then
    begin
    ShowWindow(Application.Handle, SW_HIDE);
    SetWindowLong(
                  Application.Handle,
                  GWL_EXSTYLE,
                  (
                   GetWindowLong(Application.Handle, GWL_EXSTYLE) and not WS_EX_APPWINDOW or WS_EX_TOOLWINDOW
                  )
                 );
    ShowWindow(Application.Handle, SW_SHOW);

    // Mark as appropriate with UAC "shield" icons
    AddUACShieldIcons();
    end;

  // Prevent endless loops of UAC escalation...
  AllowUACEsclation := FALSE;

  EndSessionFlag := FALSE;
  ShuttingDownFlag := FALSE;

  self.Caption := Application.Title;
  SDUSystemTrayIcon1.Tip := Application.Title;

  IconMounted:= TIcon.Create();
  IconMounted.Handle := LoadImage(hInstance, PChar(R_ICON_MOUNTED), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
  IconUnmounted:= TIcon.Create();
  IconUnmounted.Handle := LoadImage(hInstance, PChar(R_ICON_UNMOUNTED), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);

  // We set these to invisible so that if they're disabled by the user
  // settings, it doens't flicker on them off
  ToolBar1.Visible := FALSE;
  Statusbar1.Visible := FALSE;

  // Give the user a clue
  ToolBar1.ShowHint := TRUE;

  ToolBar1.Indent := 5;

  CountPortableDrivers := -1;

  StatusBar1.SimplePanel := TRUE;

end;

procedure TfrmFreeOTFEMain.actRefreshExecute(Sender: TObject);
begin
  RefreshDrives();

end;

procedure TfrmFreeOTFEMain.About1Click(Sender: TObject);
var
  aboutDlg: TAbout_F;
begin
  aboutDlg:= TAbout_F.Create(self);
  try
    aboutDlg.OTFEFreeOTFE := OTFEFreeOTFE;
    aboutDlg.ShowModal();
  finally
    aboutDlg.Free();
  end;

end;

procedure TfrmFreeOTFEMain.lvDrivesResize(Sender: TObject);
begin
  ResizeWindow();

end;


procedure TfrmFreeOTFEMain.FormResize(Sender: TObject);
begin
  ResizeWindow();

end;


// Resize the columns in the drives list so the 2nd column fills out...
procedure TfrmFreeOTFEMain.ResizeWindow();
var
  tmpColumn: TListColumn;
begin
  if lvDrives.columns.count>1 then
    begin
    tmpColumn := lvDrives.columns[1];
    tmpColumn.width := lvDrives.clientwidth - lvDrives.columns[0].width - ilDriveIcons.width;
    end;

end;


procedure TfrmFreeOTFEMain.MountFiles(mountAsSystem: TDragDropFileType; filenames: TStringList; readOnly: boolean);
var
  i: integer;
  mountedAs: string;
  msg: string;
  errMsg: string;
  mountedOK: boolean;
begin
  if (mountAsSystem = ftFreeOTFE) then
    begin
    mountedOK:= OTFEFreeOTFE.MountFreeOTFE(filenames, mountedAs, readOnly);
    end
  else if (mountAsSystem = ftLinux) then
    begin
    mountedOK:= OTFEFreeOTFE.MountLinux(filenames, mountedAs, readOnly);
    end
  else
    begin
    mountedOK:= OTFEFreeOTFE.Mount(filenames, mountedAs, readOnly);
    end;

  if not(mountedOK) then
    begin
    if (OTFEFreeOTFE.LastErrorCode <> OTFE_ERR_USER_CANCEL) then
      begin
      errMsg := 'Unable to mount volume; please ensure that you entered the '+SDUCRLF+
                'correct details (password, etc)'+SDUCRLF+
                SDUCRLF+
                'If you are using a keyfile, please ensure that you check/uncheck the'+SDUCRLF+
                '"Data from offset includes CDB" option, as appropriate for your'+SDUCRLF+
                'volume.';
      if (OTFEFreeOTFE.LastErrorCode = OTFE_ERR_NO_FREE_DEVICES) then
        begin
        errMsg := 'Your volume could not be mounted at this time as there are'+SDUCRLF+
                  'no suitable FreeOTFE devices free.'+SDUCRLF+
                  SDUCRLF+
                  'Please dismount one or more volumes, and try again.';
        end;

      SDUMessageDlg(errMsg, mtError, [mbOK], 0);
      end;

    end
  else
    begin
    if (length(mountedAs)=1) then
      begin
      msg := 'Your FreeOTFE volume has been mounted as drive: ';
      end
    else
      begin
      msg := 'Your FreeOTFE volumes have been mounted as drives: ';
      end;

    for i:=1 to length(mountedAs) do
      begin
      if (i<>1) then
        begin
        msg := msg + ', ';
        end;

      msg := msg + mountedAs[i] + ':';
      end;

    RefreshDrives();
    SDUMessageDlg(msg, mtInformation, [mbOK], 0);
    end;

end;


// Handle files being dropped onto the form from (for example) Windows Explorer.
// Files dropped onto the form should be treated as though the user is trying
// to mount them as volume files
procedure TfrmFreeOTFEMain.WMDropFiles(var Msg: TWMDropFiles);
var
  buffer: array[0..MAX_PATH] of Char;
  numFiles: longint;
  i: integer;
  filesToMount: TStringList;
begin
  try
    // Bring our window to the foreground
    SetForeGroundWindow(self.handle);

    // Handle the dropped files
    numFiles := DragQueryFile(Msg.Drop, $FFFFFFFF, nil, 0);
    filesToMount := TStringList.Create();
    try
      for i:=0 to (numFiles-1) do
        begin
        DragQueryFile(msg.Drop,
                      i,
                      @buffer,
                      sizeof(buffer));
        filesToMount.Add(buffer);
        end;

      MountFiles(Settings.OptDragDropFileType, filesToMount, FALSE);

      Msg.Result := 0;
    finally
      filesToMount.Free();
    end;
  finally
    DragFinish(Msg.Drop);
  end;

end;


procedure TfrmFreeOTFEMain.WMDeviceChange(var Msg : TMessage);
begin
  RefreshDrives();

end;


// Function required for close to system tray icon
procedure TfrmFreeOTFEMain.WMQueryEndSession(var msg: TWMQueryEndSession);
begin
  // Default to allowing shutdown
  msg.Result := 1;
  EndSessionFlag := (msg.Result = 1);
  inherited;
  EndSessionFlag := (msg.Result = 1);
  
end;


// Function required for close to system tray icon
procedure TfrmFreeOTFEMain.WMEndSession(var msg: TWMEndSession);
begin
  EndSessionFlag := msg.EndSession;

end;


procedure TfrmFreeOTFEMain.DriveProperties();
var
  propertiesDlg: TfrmFreeOTFEVolProperties;
  i: integer;
begin
  for i:=0 to (lvDrives.items.count-1) do
    begin
    if lvDrives.Items[i].Selected then
      begin
      propertiesDlg:= TfrmFreeOTFEVolProperties.Create(self);
      try
        propertiesDlg.DriveLetter := GetDriveLetterFromLVItem(lvDrives.Items[i]);
        propertiesDlg.OTFEFreeOTFE := OTFEFreeOTFE;
        propertiesDlg.ShowModal();
      finally
        propertiesDlg.Free();
      end;

      end;
    end;

end;


// If "isEmergency" is TRUE, the user will *not* be informed of any drives
// which couldn't be dismounted 
function TfrmFreeOTFEMain.DismountAll(isEmergency: boolean = FALSE): boolean;
var
  drivesRemaining: string;
  allOK: boolean;
begin
  allOK := TRUE;

  OTFEFreeOTFE.DismountAll(isEmergency);

  // If it wasn't an emergency dismount, and drives are still mounted, report.
  drivesRemaining := OTFEFreeOTFE.DrivesMounted();
  if (drivesRemaining<>'') then
    begin
    if not(isEmergency) then
      begin
      allOK := FALSE;
      RefreshDrives();
      ReportDrivesNotDismounted(drivesRemaining, FALSE);
      end
    else
      begin
      // Just give it another go... Best we can do.
      OTFEFreeOTFE.DismountAll(isEmergency);
      end;
    end;

  RefreshDrives();

  Result := allOK;
end;


function TfrmFreeOTFEMain.DismountSelected(): boolean;
var
  i: integer;
  drivesRemaining: string;
  toDismount: string;
  allOK: boolean;
begin
  drivesRemaining := '';

  // First we build up a list of drives to dismount, then we dismount them.
  // This is done since we can't just run through the lvDrives looking for
  // selected items, as they're getting removed while we walk though the list!

  for i:=0 to (lvDrives.items.count-1) do
    begin
    if lvDrives.Items[i].Selected then
      begin
      toDismount := toDismount + GetDriveLetterFromLVItem(lvDrives.Items[i]);
      end;
    end;

  allOK := DismountDrives(toDismount, FALSE);

  RefreshDrives();

  Result := allOK;
end;


// Dismount the drives specified
// This procedure *will* report drives which couldn't be mounted - regardless
// of "isEmergency"
function TfrmFreeOTFEMain.DismountDrives(dismountDrives: string; isEmergency: boolean): boolean;
var
  i: integer;
  tmpDrv: char;
  drivesRemaining: string;
  allOK: boolean;
begin
  allOK := TRUE;
  drivesRemaining := '';

  for i:=1 to length(dismountDrives) do
    begin
    tmpDrv := dismountDrives[i];
    if not(OTFEFreeOTFE.Dismount(tmpDrv, isEmergency)) then
      begin
      drivesRemaining := drivesRemaining + tmpDrv;
      allOK := FALSE;
      end;

    end;

  if (drivesRemaining<>'') then
    begin
    RefreshDrives();
    ReportDrivesNotDismounted(drivesRemaining, isEmergency);
    end;

  RefreshDrives();

  Result := allOK;
end;


// Warn the user that some drives remain mounted, and if the dismount attempted
// wasn't an emergency dismount, then prompt the user if they want to attempt
// an emergency dismount
procedure TfrmFreeOTFEMain.ReportDrivesNotDismounted(drivesRemaining: string; isEmergency: boolean);
var
  msg: string;
  i: integer;
  plural_thisthese: string;
  plural_drivedrives: string;
begin
  plural_thisthese := 'this';
  plural_drivedrives := 'drive';
  if (length(drivesRemaining)>0) then
    begin
    plural_thisthese := 'these';
    plural_drivedrives := 'drives';
    end;

  msg := 'Unable to dismount '+plural_drivedrives+': ';
  for i:=1 to length(drivesRemaining) do
    begin
    if (i<>1) then
      begin
      msg := msg + ', ';
      end;

    msg := msg + drivesRemaining[i] + ':';
    end;


  // If the dismount attempted was a non-emergency dismount; prompt user if
  // they want to attempt an emergency dismount
  if not(isEmergency) then
    begin
    msg := msg+SDUCRLF+
           SDUCRLF+
           'Do you wish to force a dismount on '+plural_thisthese+' '+plural_drivedrives+'?';

    if (SDUMessageDlg(msg, mtConfirmation, [mbYes,mbNo], 0) = mrYes)then
      begin
      if (SDUMessageDlg(
                     'Warning: Emergency dismounts are not recommended'+SDUCRLF+
                     SDUCRLF+
                     'Are you sure you wish to proceed?',
                     mtWarning,
                     [mbYes,mbNo],
                     0
                    ) = mrYes) then
        begin
        DismountDrives(drivesRemaining, TRUE);
        end;

      end;
    end
  else
    begin
    // Dismount reporting on *was* an emergency dismount; just report remaining
    // drives still mounted
    SDUMessageDlg(msg, mtInformation, [mbOK], 0);
    end;

end;



procedure TfrmFreeOTFEMain.lvDrivesClick(Sender: TObject);
begin
  EnableDisableControls();

end;

procedure TfrmFreeOTFEMain.EnableDisableControls();
var
  drivesSelected: boolean;
  drivesMounted: boolean;
  drvLetter: char;
  freeSpace: int64;
  totalSpace: int64;
  statusText: string;
  i: integer;
begin
  // The FreeOTFE object may not be active...
  actFreeOTFENew.Enabled            := OTFEFreeOTFE.Active;
  actFreeOTFEMountFile.Enabled      := OTFEFreeOTFE.Active;
  actFreeOTFEMountPartition.Enabled := (OTFEFreeOTFE.Active and OTFEFreeOTFE.CanMountDevice());
  // Linux menuitem completely disabled if not active...
  miLinuxVolume.Enabled             := OTFEFreeOTFE.Active;
  actLinuxNew.Enabled               := miLinuxVolume.Enabled;
  actLinuxMountFile.Enabled         := miLinuxVolume.Enabled;
  actLinuxMountPartition.Enabled    := (miLinuxVolume.Enabled and OTFEFreeOTFE.CanMountDevice());

  miChangePassword.Enabled := OTFEFreeOTFE.Active;
  miCreateKeyfile.Enabled  := OTFEFreeOTFE.Active;
  miCDB.Enabled            := OTFEFreeOTFE.Active;


  // Flags used later
  drivesSelected := (lvDrives.selcount > 0);
  drivesMounted  := (lvDrives.Items.count > 0);


  // Actions & menuitems to be enabled/disabled, depending on whether a drive
  // is selected
  actDismount.enabled   := drivesSelected;
  actProperties.enabled := drivesSelected;

  miFormat.enabled                  := drivesSelected;
  miPopupFormat.enabled             := drivesSelected;
  miOverwriteFreeSpace.enabled      := drivesSelected;  // Note: Implies FreeOTFE drivers are running
  miPopupOverwriteFreeSpace.enabled := drivesSelected;  // Note: Implies FreeOTFE drivers are running


  // Action item to be enabled/disabled, as long as one or more drives are
  // mounted
  actDismountAll.enabled  := drivesMounted;


  // Driver handling...
  actTogglePortableMode.Checked := (CountPortableDrivers > 0);
  actTogglePortableMode.Enabled := (
                                    OTFEFreeOTFE.CanUserManageDrivers() or
                                    // If we're on Vista, always allow the
                                    // toggle portable mode option; the
                                    // user can escalate UAC if needed
                                    SDUOSVistaOrLater()
                                   );
  // If the portable mode control is enabled, but we don't know how many
  // drivers there are in portable mode, presumably we're running under
  // Vista without admin access - in which case this control just toggles the
  // portable mode status - and DOESN'T turn it on/off
  if (
      actTogglePortableMode.Enabled and
      (CountPortableDrivers < 0)
     ) then
    begin
    actTogglePortableMode.Caption := 'Toggle portable mode drivers';
    end
  else
    begin
    actTogglePortableMode.Caption := 'Use portable mode drivers';

    // Ensure NO ICON FOR PORTABLE MODE DRIVERS if the user is admin; it shows
    // a checkbox instead, depending on whether the drivers are running or not
    miPortableModeDrivers.ImageIndex := -1;
    end;



  // Misc display related...
  SDUSystemTrayIcon1.Active         := Settings.OptSystemTrayIconDisplay;
  SDUSystemTrayIcon1.MinimizeToIcon := Settings.OptSystemTrayIconMinTo;
  if drivesMounted then
    begin
    SDUSystemTrayIcon1.Icon := IconMounted;
    end
  else
    begin
    SDUSystemTrayIcon1.Icon := IconUnmounted;
    end;

  ToolBar1.Visible := Settings.OptDisplayToolbar;
  StatusBar1.Visible := Settings.OptDisplayStatusbar;

  // Update status bar text, if visible
  if StatusBar1.Visible then
    begin
    statusText := '';
    if (lvDrives.SelCount = 0) then
      begin
      if (lvDrives.Items.Count = 1) then
        begin
        statusText := inttostr(lvDrives.Items.Count)+' drive mounted.';
        end
      else
        begin
        statusText := inttostr(lvDrives.Items.Count)+' drives mounted.';
        end;

      end
    else if (lvDrives.SelCount > 0) then
      begin
      if (lvDrives.SelCount = 1) then
        begin
        for i:=0 to (lvDrives.items.count-1) do
          begin
          if lvDrives.Items[i].Selected then
            begin
            drvLetter := GetDriveLetterFromLVItem(lvDrives.Items[i]);
            freeSpace := DiskFree(Ord(drvLetter) - 64);
            totalSpace := DiskSize(Ord(drvLetter) - 64);

            if (
                (freeSpace > -1) and
                (totalSpace > -1)
               ) then
              begin
              statusText := '';
              statusText := statusText +
                            drvLetter+':';
              statusText := statusText +
                            ' Free Space: '+SDUFormatUnits(
                                                       freeSpace,
                                                       UNITS_BYTES_DENOMINATINON,
                                                       UNITS_BYTES_MULTIPLIER,
                                                       1
                                                      );
              statusText := statusText +
                            ' Total Size: '+SDUFormatUnits(
                                                       totalSpace,
                                                       UNITS_BYTES_DENOMINATINON,
                                                       UNITS_BYTES_MULTIPLIER,
                                                       1
                                                      );
              end;
            end;

            break;
          end;
        end;

      if (statusText = '') then
        begin
        statusText := inttostr(lvDrives.SelCount)+' drives selected.';
        end;

      end;

    StatusBar1.SimpleText := statusText;
    end;

end;


function TfrmFreeOTFEMain.GetDriveLetterFromLVItem(listItem: TListItem): char;
var
  tmpDrv: string;
begin
  // Trim the padding whitespace off the drive letter + colon
  tmpDrv := listItem.Caption;
  tmpDrv := TrimLeft(tmpDrv);

  // The first letter of the item's caption is the drive letter
  Result := tmpDrv[1];

end;

procedure TfrmFreeOTFEMain.lvDrivesDblClick(Sender: TObject);
var
  driveLetter: string;
  explorerCommandLine: string;
begin
  if (lvDrives.selcount > 0) then
    begin
    driveLetter := GetDriveLetterFromLVItem(lvDrives.selected);

    if (driveLetter<>'') then
      begin
      explorerCommandLine := 'explorer '+driveLetter+':\';

      if (WinExec(PChar(explorerCommandLine), SW_RESTORE))<31 then
        begin
        SDUMessageDlg('Error running Explorer', mtError, [], 0);
        end;

      end;
    end;

end;

procedure TfrmFreeOTFEMain.actDriversExecute(Sender: TObject);
var
  UACEscalateAttempted: boolean;
begin
  UACEscalateAttempted := FALSE;

  DeactivateFreeOTFEComponent();
  try
    try
      // This is surrounded by a try...finally as it may throw an exception if
      // the user doesn't have sufficient privs to do this
      OTFEFreeOTFE.ShowDriverControlDlg();

      // Send out a message to any other running instances of FreeOTFE to
      // refresh; the drivers may have changed.
      // Note that if we had to UAC escalate (see exception below), the UAC
      // escalated process will send out this windows message
      SDUPostMessageExistingApp(GLOBAL_VAR_WM_FREEOTFE_REFRESH, 0, 0);
    except
      on EFreeOTFENeedAdminPrivs do
        begin
        UACEscalateForDriverInstallation();
        UACEscalateAttempted := TRUE;
        end;
    end;

  finally
    // Note: We supress any messages that may be the result of failing to
    //       activate the OTFEFreeOTFE componentactivating the if we had to
    //       UAC escalate.
    //       In that situation, the UAC escalated process will sent out a
    //       refresh message when it's done. 
    ActivateFreeOTFEComponent(UACEscalateAttempted);

    EnableDisableControls();
  end;

end;


function TfrmFreeOTFEMain.ActivateFreeOTFEComponent(suppressMsgs: boolean): boolean;
var
  obsoleteDriver: boolean;
begin
  obsoleteDriver:= FALSE;
  try
    OTFEFreeOTFE.Active := TRUE;
  except
    on EFreeOTFEObsoleteDriver do
      begin
      obsoleteDriver := TRUE;
      end;

  else
    // We should only get to here if the FreeOTFE driver isn't both
    // installed & started

  end;


  if (
      not(suppressMsgs) and
      not(OTFEFreeOTFE.Active) and
      not(ShuttingDownFlag)  // Don't complain to user is we're about to exit!
     ) then
    begin
    if (obsoleteDriver) then
      begin
      SDUMessageDlg(
                 'In order to use this software, you must first upgrade your '+SDUCRLF+
                 'FreeOTFE drivers to a later version.'+SDUCRLF+
                 SDUCRLF+
                 'If you have just upgraded your copy of FreeOTFE from a '+SDUCRLF+
                 'previous version, please ensure that you have followed the '+SDUCRLF+
                 'upgrade instructions that came with it, and have rebooted '+SDUCRLF+
                 'if necessary.',
                 mtError,
                 [mbOK],
                 0
                );

      end
    else
      begin
      MessageDlg(
                 'Unable to connect to the FreeOTFE driver.'+SDUCRLF+
                 SDUCRLF+
                 'Please ensure that the main "FreeOTFE" driver is installed and started.'+SDUCRLF+
                 SDUCRLF+
                 'If you have only just installed FreeOTFE, please reboot and try again.',
                 mtError,
                 [mbOK],
                 0
                );
      end;

    // Note that we don't terminate here; the user may still use the driver
    // control functionality to install and/or start the FreeOTFE driver
    end;

  // Let Windows know whether we accept dropped files or not
  DragAcceptFiles(self.Handle, OTFEFreeOTFE.Active);

  Result := OTFEFreeOTFE.Active;
end;



procedure TfrmFreeOTFEMain.DeactivateFreeOTFEComponent();
begin
  OTFEFreeOTFE.Active := FALSE;

  // Let Windows know we accept dropped files or not
  DragAcceptFiles(self.Handle, OTFEFreeOTFE.Active);

end;


// The array passed in is zero-indexed; populate elements zero to "bytesRequired"
procedure TfrmFreeOTFEMain.GenerateOverwriteData(Sender: TObject; passNumber: integer; bytesRequired: cardinal; var outputBlock: TShredBlock);
var
  i: integer;
  tempArraySize: cardinal;
  blocksizeBytes: cardinal;
  plaintext: string;
  cyphertext: string;
  IV: string;
  localIV: int64;
begin
  // Generate an array of random data containing "bytesRequired" bytes of data,
  // plus additional random data to pad out to the nearest multiple of the
  // cypher's blocksize bits
  // Cater for if the blocksize was -ve or zero
  if (TempCypherDetails.BlockSize < 1) then
    begin
    blocksizeBytes := 1;
    end
  else
    begin
    blocksizeBytes := (TempCypherDetails.BlockSize div 8);
    end;
  tempArraySize := bytesRequired + (blocksizeBytes - (bytesRequired mod blocksizeBytes));

  plaintext := '';
  for i:=1 to tempArraySize do
    begin
    plaintext := plaintext + char(random(256));
    end;


  // Adjust the IV so that this block of encrypted pseudorandom data should be
  // reasonably unique
  IV := '';
  if (TempCypherDetails.BlockSize > 0) then
    begin
    IV := StringOfChar(#0, (TempCypherDetails.BlockSize div 8));

    inc(TempCypherIV);
    localIV := TempCypherIV;

    for i:=1 to min(sizeof(localIV), length(IV)) do
      begin
      IV[i] := char((localIV AND $FF));
      localIV := localIV shr 8;
      end;

    end;

  // Encrypt the pseudorandom data generated
  if not(OTFEFreeOTFE.EncryptData(
                                  TempCypherDriver,
                                  TempCypherGUID,
                                  TempCypherKey,
                                  IV,
                                  plaintext,
                                  cyphertext
                                 )) then
    begin
    SDUMessageDlg(
               'Unable to encrypt pseudorandom data before using for '+SDUCRLF+
               'overwrite buffer?!',
               mtWarning,
               [mbOK],
               0
              );
    end;

  // Copy the encrypted data into the outputBlock
  for i:=0 to (bytesRequired-1) do
    begin
    outputBlock[i] := byte(cyphertext[i+1]);
    end;

end;


function TfrmFreeOTFEMain.PortableModeSet(setTo: TPortableModeAction; suppressMsgs: boolean): boolean;
var
  retval: boolean;
begin
  retval := FALSE;

  if not(OTFEFreeOTFE.CanUserManageDrivers()) then
    begin
    // On Vista, escalate UAC
    if SDUOSVistaOrLater() then
      begin
      UACEscalateForPortableMode(setTo, suppressMsgs);
      end
    else
      begin
      // On pre-Vista, just let user know they can't do it
      if not(suppressMsgs) then
        begin
        SDUMessageDlg(
                      TEXT_NEED_ADMIN,
                      mtWarning,
                      [mbOK],
                      0
                     );
        end;
      end;

    end
  else
    begin
    case setTo of
      pmaStart:
        begin
        retval := _PortableModeStart(suppressMsgs);
        end;

      pmaStop:
        begin
        retval := _PortableModeStop(suppressMsgs);
        end;

      pmaToggle:
        begin
        retval := _PortableModeToggle(suppressMsgs);
        end;

    end;

    // In case we UAC escalated (i.e. ran a separate process to handle the
    // drivers, we send out a message to any other running instances of
    // FreeOTFE to refresh
    SDUPostMessageExistingApp(GLOBAL_VAR_WM_FREEOTFE_REFRESH, 0, 0);
    end;

  Result := retval;
end;

function TfrmFreeOTFEMain._PortableModeStart(suppressMsgs: boolean): boolean;
var
  driverFilenames: TStringList;
  fileIterator: TSDUFileIterator;
  filename: string;
  allOK: boolean;
begin
  allOK:= FALSE;

  driverFilenames:= TStringList.Create();
  try
    // Compile a list of drivers in the CWD
    fileIterator:= TSDUFileIterator.Create(nil);
    try
      fileIterator.Directory := ExtractFilePath(Application.ExeName);
      fileIterator.FileMask := '*.sys';
      fileIterator.RecurseSubDirs := FALSE;
      fileIterator.OmitStartDirPrefix := FALSE;
      fileIterator.IncludeDirNames := FALSE;

      fileIterator.Reset();
      filename := fileIterator.Next();
      while (filename<>'') do
        begin
        driverFilenames.Add(filename);
        filename := fileIterator.Next();
        end;

    finally
      fileIterator.Free();
    end;


    if (driverFilenames.count<1) then
      begin
      if not(suppressMsgs) then
        begin
        SDUMessageDlg(
                   'Unable to locate any portable FreeOTFE drivers.'+SDUCRLF+
                   SDUCRLF+
                   'Please ensure that the a copy of the FreeOTFE drivers (".sys" files) '+SDUCRLF+
                   'you wish to use are located in the correct directory.',
                   mtWarning,
                   [mbOK],
                   0
                  );
        end;
      end
    else
      begin
      DeactivateFreeOTFEComponent();
      if OTFEFreeOTFE.PortableStart(driverFilenames, not(suppressMsgs)) then
        begin
        if not(suppressMsgs) then
          begin
          SDUMessageDlg('Portable mode drivers installed and started.', mtInformation, [mbOK], 0);
          end;
        allOK:= TRUE;
        end
      else
        begin
        if not(suppressMsgs) then
          begin
          SDUMessageDlg(
                     'One or more of your portable FreeOTFE drivers could not be '+SDUCRLF+
                     'installed/started.'+SDUCRLF+
                     SDUCRLF+
                     TEXT_NEED_ADMIN+SDUCRLF+
                     SDUCRLF+
                     'Please select "File | Drivers..." to check which drivers are '+SDUCRLF+
                     'currently operating.',
                     mtWarning,
                     [mbOK],
                     0
                    );
          end;
        end;

      end;

  finally
    driverFilenames.Free();
    ActivateFreeOTFEComponent(suppressMsgs);
  end;

  Result := allOK;
end;

function TfrmFreeOTFEMain._PortableModeStop(suppressMsgs: boolean): boolean;
var
  allOK: boolean;
  stopOK: boolean;
begin
  allOK := FALSE;

  // Note that if the component was *not* active, then we can shutdown all
  // portable mode drivers; if we aren't active, this implies the main driver
  // isn't installed/running - in which case we don't need the user to confirm
  // as no drives can be mounted
  stopOK := TRUE;
  if OTFEFreeOTFE.Active then
    begin
    if (OTFEFreeOTFE.CountDrivesMounted() > 0) then
      begin
      if suppressMsgs then
        begin
        stopOK := FALSE;
        end
      else
        begin
        stopOK := (SDUMessageDlg(
                               'You have one or more volumes mounted.'+SDUCRLF+
                               SDUCRLF+
                               'If any of the currently mounted volumes makes use of any of the '+SDUCRLF+
                               'FreeOTFE drivers which are currently in portable mode, '+SDUCRLF+
                               'stopping portable mode is not advisable.'+SDUCRLF+
                               SDUCRLF+
                               'It is recommended that you dismount all volumes before '+SDUCRLF+
                               'stopping portable mode.'+SDUCRLF+
                               SDUCRLF+
                               'Do you wish to continue stopping portable mode?',
                               mtWarning,
                               [mbYes,mbNo],
                               0
                              ) = mrYes);
        end;
      end;
    end;
    

  if stopOK then
    begin
    DeactivateFreeOTFEComponent();
    if OTFEFreeOTFE.PortableStop() then
      begin
      // No point in informing user; they would have been prompted if they
      // wanted to do this, and they can tell they've stopped as the
      // application will just exit; only popping up a messagebox if there's a
      // problem
      if not(ShuttingDownFlag) then
        begin
        if not(suppressMsgs) then
          begin
          SDUMessageDlg('Portable mode drivers stopped and uninstalled.', mtInformation, [mbOK], 0);
          end;
        end;

      allOK := TRUE;
      end
    else
      begin
      if not(suppressMsgs) then
        begin
        SDUMessageDlg(
                   'One or more of your portable FreeOTFE drivers could not be '+SDUCRLF+
                   'stopped/uninstalled.'+SDUCRLF+
                   SDUCRLF+
                   TEXT_NEED_ADMIN+SDUCRLF+
                   SDUCRLF+
                   'Please select "File | Drivers..." to check which drivers are '+SDUCRLF+
                   'currently operating.',
                   mtWarning,
                   [mbOK],
                   0
                  );
        end;
      end;

    ActivateFreeOTFEComponent(suppressMsgs);
    end;

  Result := allOK;
end;

function TfrmFreeOTFEMain._PortableModeToggle(suppressMsgs: boolean): boolean;
var
  retval: boolean;
  cntPortable: integer;
begin
  retval := FALSE;

  cntPortable := OTFEFreeOTFE.DriversInPortableMode();

  if (cntPortable < 0) then
    begin
    // We *should* be authorised to do this by the time we get here...
    // Do nothing; retval already set to FALSE
    end
  else if (cntPortable > 0) then
    begin
    retval := PortableModeSet(pmaStop, suppressMsgs);
    end
  else
    begin
    retval := PortableModeSet(pmaStart, suppressMsgs);
    end;

  Result := retval;
end;


procedure TfrmFreeOTFEMain.miCDBBackupClick(Sender: TObject);
var
  dlg: TfrmFreeOTFECDBBackupRestore;
begin
  dlg:= TfrmFreeOTFECDBBackupRestore.Create(self);
  try
    dlg.OTFEFreeOTFE := OTFEFreeOTFE;
    dlg.DlgType := opBackup;
    dlg.ShowModal();
  finally
    dlg.Free();
  end;

end;

procedure TfrmFreeOTFEMain.miCDBRestoreClick(Sender: TObject);
var
  dlg: TfrmFreeOTFECDBBackupRestore;
begin
  dlg:= TfrmFreeOTFECDBBackupRestore.Create(self);
  try
    dlg.OTFEFreeOTFE := OTFEFreeOTFE;
    dlg.DlgType := opRestore;
    dlg.ShowModal();
  finally
    dlg.Free();
  end;

end;


procedure TfrmFreeOTFEMain.miCreateKeyfileClick(Sender: TObject);
begin
  OTFEFreeOTFE.WizardCreateKeyfile();
end;

procedure TfrmFreeOTFEMain.miChangePasswordClick(
  Sender: TObject);
begin
  OTFEFreeOTFE.WizardChangePassword();
end;

procedure TfrmFreeOTFEMain.miCDBPlaintextDumpClick(Sender: TObject);
begin
  DumpDetailsToFile(FALSE);

end;



procedure TfrmFreeOTFEMain.miLUKSDumpClick(Sender: TObject);
begin
  DumpDetailsToFile(TRUE);

end;



procedure TfrmFreeOTFEMain.DumpDetailsToFile(LUKSDump: boolean);
var
  dlg: TfrmFreeOTFECDBDump;
begin
  if OTFEFreeOTFE.WarnIfNoHashOrCypherDrivers() then
    begin
    dlg:= TfrmFreeOTFECDBDump.Create(self);
    try
      dlg.LUKSDump := LUKSDump;
      dlg.OTFEFreeOTFE := OTFEFreeOTFE;
      dlg.ShowModal();
    finally
      dlg.Free();
    end;

    end;

end;


procedure TfrmFreeOTFEMain.actFreeOTFENewExecute(Sender: TObject);
begin
  if OTFEFreeOTFE.CreateFreeOTFEVolumeWizard() then
    begin
    SDUMessageDlg('FreeOTFE volume created successfully.'+SDUCRLF+
               SDUCRLF+
               'Please mount, format and overwrite this volume''s free space before use.',
               mtInformation, [mbOK], 0);
    end
  else
    begin
    if (OTFEFreeOTFE.LastErrorCode <> OTFE_ERR_USER_CANCEL) then
      begin
      SDUMessageDlg('FreeOTFE volume could not be created', mtError, [mbOK], 0);
      end;
    end;

end;

procedure TfrmFreeOTFEMain.actFreeOTFEMountFileExecute(Sender: TObject);
begin
  if OTFEFreeOTFE.WarnIfNoHashOrCypherDrivers() then
    begin
    OpenDialog.Filter     := FILE_FILTER_FLT_VOLUMES;
    OpenDialog.DefaultExt := FILE_FILTER_DFLT_NONE;

    if OpenDialog.Execute() then
      begin
      MountFiles(ftFreeOTFE, TStringList(OpenDialog.Files), (ofReadOnly in OpenDialog.Options));
      end;
    end;

end;

procedure TfrmFreeOTFEMain.actFreeOTFEMountPartitionExecute(
  Sender: TObject);
var
  selectedPartition: string;
  mountList: TStringList;
begin
  if OTFEFreeOTFE.WarnIfNoHashOrCypherDrivers() then
    begin
    selectedPartition := OTFEFreeOTFE.SelectPartition();

    if (selectedPartition <> '') then
      begin
      mountList:= TStringList.Create();
      try
        mountList.Add(selectedPartition);
        MountFiles(ftFreeOTFE, mountList, FALSE);
      finally
        mountList.Free();
      end;

      end;
    end;

end;

procedure TfrmFreeOTFEMain.actDismountExecute(Sender: TObject);
begin
  DismountSelected();

end;

procedure TfrmFreeOTFEMain.actDismountAllExecute(Sender: TObject);
begin
  DismountAll();

end;

procedure TfrmFreeOTFEMain.actLinuxNewExecute(Sender: TObject);
begin
  if OTFEFreeOTFE.CreateLinuxVolumeWizard() then
    begin
    SDUMessageDlg('Linux volume created successfully.'+SDUCRLF+
               SDUCRLF+
               'Don''t forget to mount and format this volume before use.',
               mtInformation, [mbOK], 0);
    end
  else
    begin
    if (OTFEFreeOTFE.LastErrorCode <> OTFE_ERR_USER_CANCEL) then
      begin
      SDUMessageDlg('Linux volume could not be created', mtError, [mbOK], 0);
      end;
    end;

end;

procedure TfrmFreeOTFEMain.actLinuxMountFileExecute(Sender: TObject);
begin
  if OTFEFreeOTFE.WarnIfNoHashOrCypherDrivers() then
    begin
    OpenDialog.Filter     := FILE_FILTER_FLT_VOLUMES;
    OpenDialog.DefaultExt := FILE_FILTER_DFLT_NONE;

    if OpenDialog.Execute() then
      begin
      MountFiles(ftLinux, TStringList(OpenDialog.Files), (ofReadOnly in OpenDialog.Options));
      end;
    end;

end;

procedure TfrmFreeOTFEMain.actLinuxMountPartitionExecute(Sender: TObject);
var
  selectedPartition: string;
  mountList: TStringList;
begin
  if OTFEFreeOTFE.WarnIfNoHashOrCypherDrivers() then
    begin
    selectedPartition := OTFEFreeOTFE.SelectPartition();

    if (selectedPartition <> '') then
      begin
      mountList:= TStringList.Create();
      try
        mountList.Add(selectedPartition);
        MountFiles(ftLinux, mountList, FALSE);
      finally
        mountList.Free();
      end;

      end;
    end;

end;

procedure TfrmFreeOTFEMain.actPropertiesExecute(Sender: TObject);
begin
  DriveProperties();

end;

// Function required for both close and minimize to system tray icon
procedure TfrmFreeOTFEMain.actExitExecute(Sender: TObject);
begin
  // Either:
  //   Application.Terminate();
  // Or:
  SDUSystemTrayIcon1.Active := FALSE;
  Close();
end;

procedure TfrmFreeOTFEMain.miOptionsClick(Sender: TObject);
var
  dlg: TfrmOptions;
begin
  dlg := TfrmOptions.Create(self);
  try
    if (dlg.ShowModal() = mrOK) then
      begin
      SetupHotKeys();
      EnableDisableControls();
      end;
      
  finally
    dlg.Free();
  end;

end;

// Function required for both close and minimize to system tray icon
procedure TfrmFreeOTFEMain.actDisplayConsoleExecute(Sender: TObject);
begin
  SDUSystemTrayIcon1.DoRestore();

end;


procedure TfrmFreeOTFEMain.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
var
  userConfirm: WORD;
  oldActive: boolean;
  closingDrivesMounted: integer;
begin
  CanClose := TRUE;

  closingDrivesMounted := 0;

  // This code segment is required to handle the case when Close() is called
  // programatically
  // Only carry out this action if closing to SystemTrayIcon
  // Note the MainForm test; if it was not the main form, setting Action would
  // in FormClose would do the minimise
  if (
      not(EndSessionFlag) and
      SDUSystemTrayIcon1.Active and
      Settings.OptSystemTrayIconCloseTo and
      (Application.MainForm = self)
     ) then
    begin
    CanClose := FALSE;
    SDUSystemTrayIcon1.DoMinimizeToIcon();
    end;

  if (CanClose) then
    begin
    oldActive := OTFEFreeOTFE.Active;
    // We (quite reasonably) assume that if the FreeOTFE component is *not*
    // active, and we can't activate it, then no FreeOTFE volumes are mounted
    if not(OTFEFreeOTFE.Active) then
      begin
      // Prevent any warnings...
      ShuttingDownFlag := TRUE;
      ActivateFreeOTFEComponent(FALSE);
      // Reset flag
      ShuttingDownFlag := FALSE;
      end;

    if (OTFEFreeOTFE.Active) then
      begin
      if (OTFEFreeOTFE.CountDrivesMounted() > 0) then
        begin
        userConfirm := SDUMessageDlg(
                                  'One or volumes are still mounted.'+SDUCRLF+
                                  SDUCRLF+
                                  'Do you wish to dismount all volumes before exiting?',
                                  mtConfirmation, [mbYes, mbNo, mbCancel], 0
                                 );

        if (userConfirm = mrCancel) then
          begin
          CanClose := FALSE;
          end
        else if (userConfirm = mrYes) then
          begin
          CanClose := DismountAll();
          end
        else
          begin
          CanClose := TRUE;
          end;

        end;

      closingDrivesMounted := OTFEFreeOTFE.CountDrivesMounted();
      end;  // if (OTFEFreeOTFE.Active) then

    if not(oldActive) then
      begin
      // Prevent any warnings...
      ShuttingDownFlag := TRUE;
      DeactivateFreeOTFEComponent();
      // Reset flag
      ShuttingDownFlag := FALSE;
      end;

    end;


  if (CanClose) then
    begin
    // If there's no drives mounted, and running in portable mode, prompt for
    // portable mode shutdown
    if (
        (closingDrivesMounted <= 0) and
        (OTFEFreeOTFE.DriversInPortableMode() > 0)
       ) then
      begin
      userConfirm := SDUMessageDlg(
                                 'One or more FreeOTFE drivers is running in portable mode.'+SDUCRLF+
                                 SDUCRLF+
                                 'Do you wish to shutdown portable mode before exiting?',
                                 mtConfirmation, [mbYes, mbNo, mbCancel], 0);

      if (userConfirm = mrCancel) then
        begin
        CanClose := FALSE;
        end
      else if (userConfirm = mrYes) then
        begin
        ShuttingDownFlag := TRUE;
        CanClose := PortableModeSet(pmaStop, FALSE);
        ShuttingDownFlag := CanClose;
        end
      else
        begin
        CanClose := TRUE;
        end;

      end;

    end;  // if (CanClose) then

  if CanClose then
    begin
    DestroySysTrayIconMenuitems();
    Application.ProcessMessages();
    Application.UnhookMainWindow(MessageHook);
    OTFEFreeOTFE.Active := FALSE;
    end;

end;


// Function required for close to system tray icon
// Note: This is *only* required in your application is you intend to call
//       Close() to hide/close the window. Calling Hide() instead is preferable
procedure TfrmFreeOTFEMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  // This code segment is required to handle the case when Close() is called
  // programatically
  // Only carry out this action if closing to SystemTrayIcon
  // Note the MainForm test; if it was the main form, setting Action would have
  // no effect
  if (
      not(EndSessionFlag) and
      SDUSystemTrayIcon1.Active and
      Settings.OptSystemTrayIconCloseTo and
      (Application.MainForm <> self)
     ) then
    begin
    Action := caMinimize;
    end
  else
    begin
    IconMounted.Free();
    IconMounted := nil;
    IconUnmounted.Free();
    IconUnmounted := nil;
    end;

end;


// This is used to ensure that only one copy of FreeOTFE is running at any
// given time
function TfrmFreeOTFEMain.MessageHook(var msg: TMessage): boolean;
var
  retVal: boolean;
  hotKeyMsg: TWMHotKey;
begin
  retVal := FALSE;
  if (msg.Msg = GLOBAL_VAR_WM_FREEOTFE_RESTORE) then
    begin
    // Restore application
    actDisplayConsole.Execute();

    msg.Result := 0;
    retVal := TRUE;
    end
  else if (msg.Msg = GLOBAL_VAR_WM_FREEOTFE_REFRESH) then
    begin
    actRefreshExecute(nil);
    end
  else if (msg.Msg = WM_HOTKEY) then
    begin
    // Hotkey window message handler
    hotKeyMsg := TWMHotKey(msg);
    
    if OTFEFreeOTFE.Active then
      begin
      if (hotKeyMsg.HotKey = HOTKEY_IDENT_DISMOUNT) then
        begin
        // We'll allow errors in dismount to be reported to the user; it's just
        // a normal dismount
        DismountAll(FALSE);
        end
      else if (hotKeyMsg.HotKey = HOTKEY_IDENT_DISMOUNTEMERG) then
        begin
        // Panic! The user pressed the emergency dismount hotkey! Better not
        // report any errors to the user
        DismountAll(TRUE);
        end;
      end;
    end;

  Result := retVal;
end;



// Cleardown and setup hotkeys
procedure TfrmFreeOTFEMain.SetupHotKeys();
begin
  // Cleardown any existing hotkeys...
  DisableHotkey(HOTKEY_IDENT_DISMOUNT);
  DisableHotkey(HOTKEY_IDENT_DISMOUNTEMERG);

  // ...And setup hotkeys again
  if Settings.OptHKeyEnableDismount then
    begin
    EnableHotkey(
                 Settings.OptHKeyKeyDismount,
                 HOTKEY_IDENT_DISMOUNT
                );
    end;

  if Settings.OptHKeyEnableDismountEmerg then
    begin
    EnableHotkey(
                 Settings.OptHKeyKeyDismountEmerg,
                 HOTKEY_IDENT_DISMOUNT
                );
    end;

end;

// Enable the specified shortcut as a hotkey, which will callback using the
// given identifier
procedure TfrmFreeOTFEMain.EnableHotkey(hotKey: TShortCut; hotKeyIdent: integer);
var
  modifiers : integer;
  vk  : word;
  shiftState : TShiftState;
begin
  if (hotkey = TextToShortCut(HOTKEY_TEXT_NONE)) then
    begin
    DisableHotkey(hotkeyIdent);
    end
  else
    begin
    // Obtain the virtual keycode and shiftState
    ShortCutToKey(hotkey, vk, shiftState);

    // Convet TShiftState into a modifier value for RegisterHotKey
    modifiers := 0;
    if (ssCtrl in shiftState) then
      begin
      modifiers := modifiers OR MOD_CONTROL;
      end;
    if (ssAlt in shiftState) then
      begin
      modifiers := modifiers OR MOD_ALT;
      end;
    if (ssShift in shiftState) then
      begin
      modifiers := modifiers OR MOD_SHIFT;
      end;

    DisableHotkey(hotkeyIdent);
    if not(RegisterHotkey(Application.Handle, hotkeyIdent, modifiers, vk)) then
      begin
      SDUMessageDlg(
                 'Error: Unable to assign hotkey '+ShortCutToText(hotkey),
                 mtError,
                 [mbOK],
                 0
                );
      end;

    end;

end;

// Disable the hotkey with the specifid identifier
procedure TfrmFreeOTFEMain.DisableHotkey(hotKeyIdent: integer);
begin
  UnRegisterHotkey(Application.Handle, hotkeyIdent);
end;


procedure TfrmFreeOTFEMain.actTogglePortableModeExecute(Sender: TObject);
begin
  if (
      actTogglePortableMode.Enabled and
      (CountPortableDrivers < 0)
     ) then
    begin
    PortableModeSet(pmaToggle, FALSE);
    end
  else if actTogglePortableMode.checked then
    begin
    PortableModeSet(pmaStop, FALSE);
    end
  else
    begin
    PortableModeSet(pmaStart, FALSE);
    end;

  CountPortableDrivers := OTFEFreeOTFE.DriversInPortableMode();
  EnableDisableControls();

end;

procedure TfrmFreeOTFEMain.lvDrivesSelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
begin
  EnableDisableControls();

end;

procedure TfrmFreeOTFEMain.actFormatExecute(Sender: TObject);
const
  FORMAT_CAPTION = 'Format';
var
  i: integer;
  currDrive: char;
  driveNum: word;
begin
  for i:=0 to (lvDrives.items.count-1) do
    begin
    if lvDrives.Items[i].Selected then
      begin
      currDrive := GetDriveLetterFromLVItem(lvDrives.Items[i]);
      driveNum := ord(currDrive) - ord('A');
      SHFormatDrive(Handle, driveNum, SHFMT_ID_DEFAULT, SHFMT_OPT_FULL);
      end;
    end;

  // This is *BIZARRE*.
  // If you are running under Windows Vista, and you mount a volume for
  // yourself only, and then try to format it, the format will fail - even if
  // you UAC escalate to admin
  // That's one thing - HOWEVER! After it fails, for form's title is set to:
  //   Format <current volume label> <drive letter>:
  // FREAKY!
  // OTOH, it does means we can detect and inform the user that the format
  // just failed...
  if (Pos(uppercase(FORMAT_CAPTION), uppercase(self.Caption)) > 0) then
    begin
    self.Caption := Application.Title;
    SDUMessageDlg(
                  'Your encrypted drive could not be formatted at this time.'+SDUCRLF+
                  SDUCRLF+
                  'Please dismount this volume and remount it with the "Mount for all users" option checked,'+SDUCRLF+
                  'before trying again.',
                  mtError,
                  [mbOK],
                  0
                 );
    end;

  RefreshDrives();

end;


procedure TfrmFreeOTFEMain.actOverwriteFreeSpaceExecute(Sender: TObject);
var
  shredder: TShredder;
  i: integer;
  currDrive: char;
  frmOverWriteMethod: TfrmFreeOTFESelectOverwriteMethod;
  overwriteWithEncryptedData: boolean;
  allOK: boolean;
  getRandomBits: integer;
  getRandomBytes: integer;
  randomBuffer: array of byte;
  overwriteOK: integer;
begin
  overwriteOK := 0;
  allOK := FALSE;
  overwriteWithEncryptedData := FALSE;

  frmOverWriteMethod:= TfrmFreeOTFESelectOverwriteMethod.Create(self);
  try
    frmOverWriteMethod.OTFEFreeOTFEObj := OTFEFreeOTFE;
    if (frmOverWriteMethod.ShowModal() = mrOK) then
      begin
      allOK := TRUE;

      overwriteWithEncryptedData := frmOverWriteMethod.OverwriteWithEncryptedData;
      if (overwriteWithEncryptedData) then
        begin
        TempCypherDriver:= frmOverWriteMethod.CypherDriver;
        TempCypherGUID:= frmOverWriteMethod.CypherGUID;

        OTFEFreeOTFE.GetSpecificCypherDetails(TempCypherDriver, TempCypherGUID, TempCypherDetails);

        // Initilize zeroed IV for encryption
        TempCypherIV := 0;

        // Get *real* random data for encryption key
        getRandomBits := 0;
        if (TempCypherDetails.KeySize < 0) then
          begin
          // -ve keysize = arbitary keysize supported - just use 512 bits
          getRandomBits := 512;
          end
        else if (TempCypherDetails.KeySize > 0) then
          begin
          // +ve keysize = specific keysize - get sufficient bits
          getRandomBits := TempCypherDetails.KeySize;
          end;

        if (getRandomBits>0) then
          begin
          MouseRNGDialog1.RequiredBits := getRandomBits;
          allOK := MouseRNGDialog1.Execute();
          end;

        if (allOK) then
          begin
          getRandomBytes := (getRandomBits div 8);
          SetLength(randomBuffer, getRandomBytes);
          MouseRNGDialog1.RandomData(getRandomBytes, randomBuffer);

          for i:=low(randomBuffer) to high(randomBuffer) do
            begin
            TempCypherKey := TempCypherKey + char(randomBuffer[i]);
            // Overwrite the temp buffer...
            randomBuffer[i] := random(256);
            end;
          SetLength(randomBuffer, 0);
          end;

        end;

      end;

  finally
    frmOverWriteMethod.Free();
  end;



  if (allOK) then
    begin
    if (SDUMessageDlg(
                   'Overwriting all the free space on a large volume may take awhile'+SDUCRLF+
                   SDUCRLF+
                   'Are you sure you wish to proceed?',
                    mtConfirmation,
                   [mbYes,mbNo],
                   0
                  ) = mrYes) then
      begin
      shredder:= TShredder.Create(nil);
      try
        if overwriteWithEncryptedData then
          begin
          shredder.OnOverwriteDataReq := GenerateOverwriteData;
          end
        else
          begin
          shredder.OnOverwriteDataReq := nil;
          end;


        for i:=0 to (lvDrives.items.count-1) do
          begin
          if lvDrives.Items[i].Selected then
            begin
            currDrive := GetDriveLetterFromLVItem(lvDrives.Items[i]);
            overwriteOK := shredder.OverwriteDriveFreeSpace(currDrive, FALSE);
            end;
          end;

        if (overwriteOK = 1) then
          begin
          SDUMessageDlg('Overwrite operation complete.', mtInformation, [mbOK], 0);
          end
        else if (overwriteOK = -1) then
          begin
          SDUMessageDlg(
                     'Overwrite operation FAILED.'+SDUCRLF+
                     SDUCRLF+
                     'Did you remember to format this drive first?',
                     mtError, [mbOK], 0
                    );
          end
        else if (overwriteOK = -2) then
          begin
          SDUMessageDlg('Overwrite operation cancelled by user.', mtInformation, [mbOK], 0);
          end
        else
          begin
          SDUMessageDlg('No drives selected to overwrite?', mtInformation, [mbOK], 0);
          end;


      finally
        shredder.Free();
      end;

    end;  // if (SDUMessageDlg(
  end;  // if (allOK) then

  TempCypherDriver:= '';
  TempCypherGUID:= StringToGUID('{00000000-0000-0000-0000-000000000000}');
  TempCypherKey := '';
  TempCypherIV := 0;

end;

procedure TfrmFreeOTFEMain.pbtbTogglePortableModeMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  // This is ugly, but required since if the button is clicked on, and the
  // operation cancelled, the button pops up - even though it shouldn't!
  pbtbTogglePortableMode.down  := (CountPortableDrivers > 0);

end;


// Handle any command line options; returns TRUE if command line options
// were passed through
function TfrmFreeOTFEMain.HandleCommandLineOpts(var exitCode: integer): boolean;
var
  paramValue: string;
  force: boolean;
  drive: char;
  volume: string;
  readonly: boolean;
  mountAs: string;
  dismountOK: boolean;
begin
  exitCode := CMDLINE_EXIT_INVALID_CMDLINE;

  AllowUACEsclation := not(SDUCommandLineSwitch(CMDLINE_NOUACESCALATE));

  if SDUCommandLineSwitch(CMDLINE_DRIVERINSTALL) then
    begin
    actDriversExecute(nil);
    end;

  // Portable mode on/off...
  if SDUCommandLineParameter(CMDLINE_PORTABLE, paramValue) then
    begin
    if (lowercase(paramValue) = CMDLINE_TOGGLE) then
      begin
      if PortableModeSet(
                         pmaToggle,
                         SDUCommandLineSwitch(CMDLINE_SUPPRESS)
                        ) then
        begin
        exitCode := CMDLINE_SUCCESS;
        end
      else
        begin
        exitCode := CMDLINE_EXIT_UNABLE_TO_START_PORTABLE_MODE;
        end;
      end
    else if (
             (lowercase(paramValue) = CMDLINE_START) or
             (lowercase(paramValue) = CMDLINE_ON) or
             (paramValue = '1')
            ) then
      begin
      if PortableModeSet(
                         pmaStart,
                         SDUCommandLineSwitch(CMDLINE_SUPPRESS)
                        ) then
        begin
        exitCode := CMDLINE_SUCCESS;
        end
      else
        begin
        exitCode := CMDLINE_EXIT_UNABLE_TO_START_PORTABLE_MODE;
        end;
      end
    else if (
             (lowercase(paramValue) = CMDLINE_STOP) or
             (lowercase(paramValue) = CMDLINE_OFF) or
             (paramValue = '0')
            ) then
      begin
      if PortableModeSet(
                         pmaStop,
                         SDUCommandLineSwitch(CMDLINE_SUPPRESS)
                        ) then
        begin
        exitCode := CMDLINE_SUCCESS;
        end
      else
        begin
        exitCode := CMDLINE_EXIT_UNABLE_TO_STOP_PORTABLE_MODE;
        end;
      end
    end
  else
    begin
    if not(ActivateFreeOTFEComponent(TRUE)) then
      begin
      exitCode := CMDLINE_EXIT_UNABLE_TO_CONNECT;
      end
    else
      begin
      // Mount...
      if (
          SDUCommandLineSwitch(CMDLINE_MOUNT) and
          SDUCommandLineParameter(CMDLINE_VOLUME, volume)
         ) then 
        begin
        readonly := SDUCommandLineSwitch(CMDLINE_READONLY);

        if SDUCommandLineSwitch(CMDLINE_FREEOTFE) then
          begin
          mountAs := OTFEFreeOTFE.MountFreeOTFE(volume, readOnly);
          end
        else if SDUCommandLineSwitch(CMDLINE_LINUX) then
          begin
          mountAs := OTFEFreeOTFE.MountLinux(volume, readOnly);
          end
        else if (Settings.OptDragDropFileType = ftFreeOTFE) then
          begin
          mountAs := OTFEFreeOTFE.MountFreeOTFE(volume, readOnly);
          end
        else if (Settings.OptDragDropFileType = ftLinux) then
          begin
          mountAs := OTFEFreeOTFE.MountLinux(volume, readOnly);
          end
        else
          begin
          mountAs := OTFEFreeOTFE.Mount(volume, readOnly);
          end;

        if (mountAs <> #0) then
          begin
          exitCode := CMDLINE_SUCCESS;
          end
        else
          begin
          exitCode := CMDLINE_EXIT_UNABLE_TO_MOUNT;
          end;

        end
      else if SDUCommandLineParameter(CMDLINE_DISMOUNT, paramValue) then
        // Dismount...
        begin
        force := SDUCommandLineSwitch(CMDLINE_FORCE);

        if (lowercase(paramValue) = CMDLINE_ALL) then
          begin
          dismountOK := (OTFEFreeOTFE.DismountAll(force) = '');
          end
        else
          begin
          // Only use the 1st char...
          drive := paramValue[1];

          dismountOK := OTFEFreeOTFE.Dismount(drive, force);
          end;

        if dismountOK then
          begin
          exitCode := CMDLINE_SUCCESS;
          end
        else
          begin
          exitCode := CMDLINE_EXIT_UNABLE_TO_DISMOUNT;
          end;

        end;

      DeactivateFreeOTFEComponent();
      end;
    end;

  Result := (ParamCount > 0);
end;


// Vista fix
procedure TfrmFreeOTFEMain.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  if SDUOSVistaOrLater() then
    begin
    Params.ExStyle := Params.ExStyle and not WS_EX_TOOLWINDOW or WS_EX_APPWINDOW;
    end;

end;

// Vista fix
procedure TfrmFreeOTFEMain.WMSyscommand(var Message: TWmSysCommand);
begin
  if not(SDUOSVistaOrLater()) then
    begin
    inherited;
    end
  else
    begin
    case (Message.CmdType and $FFF0) of
      SC_MINIMIZE:
        begin
        ShowWindow(Handle, SW_MINIMIZE);
        Message.Result := 0;
        end;

      SC_RESTORE:
        begin
        ShowWindow(Handle, SW_RESTORE);
        Message.Result := 0;
        end;

    else
      begin
      inherited;
      end;

    end;
  end;

end;

procedure TfrmFreeOTFEMain.UACEscalateForDriverInstallation();
begin
  UACEscalate(CMDLINE_SWITCH_IND + CMDLINE_DRIVERINSTALL, FALSE);

end;

procedure TfrmFreeOTFEMain.UACEscalateForPortableMode(portableAction: TPortableModeAction; suppressMsgs: boolean);
var
  cmdLinePortableSwitch: string;
begin
  case portableAction of
    pmaStart:
      begin
      cmdLinePortableSwitch := CMDLINE_START;
      end;

    pmaStop:
      begin
      cmdLinePortableSwitch := CMDLINE_STOP;
      end;

    pmaToggle:
      begin
      cmdLinePortableSwitch := CMDLINE_TOGGLE;
      end;

  end;
  
  UACEscalate(
              CMDLINE_SWITCH_IND + CMDLINE_PORTABLE+ ' ' +cmdLinePortableSwitch,
              suppressMsgs
             );

end;

procedure TfrmFreeOTFEMain.UACEscalate(cmdLineParams: string; suppressMsgs: boolean);
const
  VERB_RUNAS = 'runas';
var
  filenameAndPath: string;
  cwd: string;
begin
  // Only applicable in Windows Vista; simply warn user they can't continue on
  // earlier OSs
  if (
      not(SDUOSVistaOrLater()) or
      not(AllowUACEsclation)
     ) then
    begin
    if not(suppressMsgs) then
      begin
      SDUMessageDlg(TEXT_NEED_ADMIN, mtError, [mbOK], 0);
      end;
    end
  else
    begin
    // Prevent endless loops of UAC escalation...
    cmdLineParams := CMDLINE_SWITCH_IND + CMDLINE_NOUACESCALATE +
                     ' ' + cmdLineParams;

    // Message supression
    if suppressMsgs then
      begin
      cmdLineParams := CMDLINE_SWITCH_IND + CMDLINE_SUPPRESS +
                       ' ' + cmdLineParams;
      end;

    filenameAndPath := ParamStr(0);
    cwd := ExtractFilePath(filenameAndPath);

    ShellExecute(
                 self.Handle,
                 VERB_RUNAS,
                 PChar(filenameAndPath),
                 PChar(cmdLineParams),
                 PChar(cwd),
                 SW_SHOW
                );

    // The UAC escalation/reexecution of FreeOTFE as UAC may have changed the
    // drivers installed/running; flush any caches in the FreeOTFE object
    OTFEFreeOTFE.CachesFlush();
    end;

end;

END.



