// Description: 
// By Sarah Dean
// Email: sdean12@sdean12.org
// WWW:   http://www.FreeOTFE.org/
//
// -----------------------------------------------------------------------------
//


#ifndef _DriverInterfaceHash_H
#define _DriverInterfaceHash_H   1

#include "FreeOTFE4PDAHashAPI.h"


// =========================================================================
// Constants....

#define STR_FORMAT_FULL_HASH_TITLE    TEXT("%ls (%d/%d)")


// =========================================================================
// Structures...

typedef struct _MODULE_DETAILS_HASH {
    WCHAR* Filename;
    HINSTANCE Lib;

    PHashDLLFnIdentifyDriver     FnIdentifyDriver;
    PHashDLLFnIdentifySupported  FnIdentifySupported;
    PHashDLLFnGetHashDetails     FnGetHashDetails;
    PHashDLLFnHash               FnHash;
} MODULE_DETAILS_HASH, *PMODULE_DETAILS_HASH;


// =========================================================================
// Functions...

BOOL driver_HashLoadDLL(WCHAR* Filename, MODULE_DETAILS_HASH* DLLDetails);
void driver_HashUnloadDLL(MODULE_DETAILS_HASH* DLLDetails);
BOOL driver_HashGetDriverDetails(WCHAR* HashFilename, HASH_DRIVER_INFO* driverInfo);
void driver_HashFreeDriverDetails(HASH_DRIVER_INFO* driverInfo);
BOOL
driver_HashGetImplDetails(
    WCHAR* HashFilename, 
    GUID* HashImpl, 
    HASH* ImplDetails
);

void driver_HashPrettyprintAlgTitle(
    HASH* hashInfo, 
    WCHAR* buffer,
    int bufferSize  // In bytes
);

BOOL driver_HashData(
    WCHAR* HashDriverFilename,
    GUID HashGUID,
    unsigned int BufferSizeIn,  // In *bits*
    unsigned char* BufferIn,
    unsigned int* ptrBufferSizeOut,  // In *bits*
    unsigned char* BufferOut
);


// =========================================================================
// =========================================================================

#endif

